/*
 * memory_manager.h
 *
 *  Created on: 23.01.2013
 *      Author: pk
 *
 *   IMPROVEMENT: Since reading large datasets is essential for our product, please look at ways to speed up the driver.
 *   ISSUE: REPIN-11
 *   SOLUTION: New mamory management
 *   FIXED BY: Kopychenko Pavel
 *   DATE: 22.01.2013
 *
 *
 */

#ifndef MEMORY_MANAGER_H_
#define MEMORY_MANAGER_H_

#include <stdlib.h>
#include <stdio.h>

#ifndef bool
typedef char bool;
#endif

#ifndef TRUE
#define	TRUE	(bool)1
#endif /* TRUE */

#ifndef	FALSE
#define	FALSE	(bool)0
#endif /* FALSE */

/* DEFAULT CONSTANTS */
#define MIN_MEM_BLOCK_SIZE			1000000 // chars -> bytes
#define PREDICT_MEM_CELL_COUNT		10
#define BLOCK_COUNT_FOR_GC_START	100
#define GCR_MAX 					2000

extern int min_mem_block_size;
extern int predict_mem_cell_count;
extern int block_count_for_gc_start;


extern int gsr;


/* Memory block */
typedef struct MemoryBlock_ {
	//static unsigned int statisticValue;

	char* pDump;	// first char of dump
	char* pDumpEnd;	// end char of dump
	char* pLast;	// last selected

	int usedFragmensCount; // fragmets in use count
	short int isCleaningMode;

	struct MemoryBlock_* pNextMemoryBlock;
} MemoryBlock;

//typedef struct MemoryBlock_ MemoryBlock;

/* Head of memory blocks list */
extern struct MemoryBlock_* pHeadOfMemoryBlocks;
extern struct MemoryBlock_* pEndOfMemoryBlocks;


char* getMemory(int size);

bool freeMemory(char* mem, MemoryBlock* _pHeadOfMemoryBlocks,
		MemoryBlock* _pEndOfMemoryBlocks);

#endif /* MEMORY_MANAGER_H_ */
